/*
 * Auspice Services is copyright (c) 2000-2001 In Mean
 *     E-mail: auspice@pleaselook.com
 * SirvNET Services is copyright (c) 1998-2000 Trevor Klingbeil.
 *     E-mail: <priority1@dal.net>
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "../inc/services.h"

char *REMOTE_SERVER = NULL;
int REMOTE_PORT = 0;
char *PASSWORD = NULL;
char *SERVER_NAME = NULL;
char *SERVER_DESC = NULL;
char *SERVICES_USER = NULL;
char *SERVICES_HOST = NULL;
char *NETWORK_NAME = NULL;
char *SERVICES_MASTER = NULL;
char *SERVICES_MASTER2 = NULL;

char *remote_server = NULL;    /* -remote server[:port] */
int remote_port = 0;
char *password = NULL;
char *server_name = NULL;        /* -name servername */
char *server_desc = NULL;        /* -desc serverdesc */
char *services_user = NULL;    /* -user username */
char *services_host = NULL;    /* -host hostname */

char *NICKSERV_NAME = "NickServ";
char *CHANSERV_NAME = "ChanServ";
char *MEMOSERV_NAME = "MemoServ";
char *HELPSERV_NAME = "HelpServ";
char *OPERSERV_NAME = "OperServ";
char *ROOTSERV_NAME = "RootServ";
char *GLOBAL_NOTICER_NAME = "Global";
char *AGENT_NAME = "Agent";

char *ADMIN_NAME = "In Mean";
char *ADMIN_EMAIL = "auspice@pleaselook.com";
char *PASS_EMAIL = "ircpass@pleaselook.com";
char *sendmail_path = "/usr/sbin/sendmail";
char *SpamUser = "sophoan";
char *Spamhost = "pl-32.camnet.com.kh";
char *Spamreal = "ircII User";
char *nsurl = "http://auspice.sourceforge.net/html/ns.htm";
char *csurl = "http://auspice.sourceforge.net/html/cs.htm";
char *guesturl = "http://auspice.sourceforge.net/html/guest.htm";

char *s_NickServ = "NickServ";
char *s_ChanServ = "ChanServ";
char *s_MemoServ = "MemoServ";
char *s_HelpServ = "HelpServ";
char *s_OperServ = "OperServ";
char *s_RootServ = "RootServ";
char *s_SpamChecker = "Guest78382";
char *s_GlobalNoticer = "Global";
char *s_ServicesX = "X";
char *s_ServicesW = "W";
char *s_Agent = "Agent";

char *TIMEZONE = "GMT";
char *SLOG_FILENAME = "./logs/services.log";
char *HELPSERV_DIR = "helpfiles";
char *HELPSERV_DIRM = "helpfiles";
// char *HELPSERV_DIRM = "helpmay";
int UPDATE_TIMEOUT = 1800;
int TIMEOUT_CHECK = 2;
int READ_TIMEOUT = 9;
int BAD_PW_LIMIT = 5;
int BAD_PW_TIMEOUT = 3600;
int CHANNEL_MAXREG = 20;
int CHANNEL_EXPIRE = 30;
int AKICK_MAX = 100;
char *DEF_AKICK_REASON = "User has been banned from the channel";
int NS_REG_DELAY = 15;
int NICK_EXPIRE = 30;
int RELEASE_TIMEOUT = 30;
int DEF_MAX_MEMOS = 50;
int MEMO_SEND_WAIT = 5;
int MEMO_EXPIRE = 30;
int MAX_SERVROOTS = 32;
int MAX_SERVADMINS = 32;
int MAX_SERVOPERS = 32;
int MAX_HELPOPS = 32;
int MAX_AUTOKILLS = 256;
int MAX_JUPES = 12;
int MAX_TRIGGERS = 128;
int AKILL_DEF_EXPIRY = (24*60*60);
int IGNORE_DEF_EXPIRY = (24*60*60);
int CLONE_MIN_USERS = 5;
int CLONE_WARNING_DELAY = 10;
int MAX_MEMO_LENGTH = 255;
int ENABLE_LOGS = 1;
int CHAN_ACCESS_MAX = 900;
int USER_ACCESS_MAX = 20;
int MAX_SUSPEND = 256;
int ENABLE_R_MODES = 0;
int ENABLE_UMODE_a = 1;
int MAX_QLINES = 64;
int MAX_ZLINES = 128;
int ALLOW_EMAIL = 1;
int F_TLEV = 10;
int F_RESET = 15;
int BACKUP_DB = 10;
int CUSTOM_NOTICE = 0;
int GENERIC_NOTICE = 1;
int INCLUDE_AKILL_REASON = 1;
int EXTRA_SNOOP = 1;
char *snoopchan = "#Snoop";
int REG_SAVES = 0;
int DISPLAY_UPDATES = 1;
int CHANNEL_INHABIT = 15;
int MOTD_UPTIME = 1;
int MOTD_UPDATE = 1;
char *DEF_MLOCKS = "+rnt";
char *spyhost;

int TOPIC_PROBS = 0;

int NOHOST_CONF = 1;
int AUTO_NOHOST = 1;
int NS_KILL = 0;
int NS_SECURE = 0;
int NS_PRIVATE = 0;
int NS_DACCESS = 0;
int CHANX = 0;
int SPRIV = 0;
int AUTOUP = 0;
int HIDEUME = 0;
int ALLOWCLIST = 0;
char *ACHANS = "#plz";
char *AOCHANS = "#dragon";
int AUTOJOINC = 0;
int OPERJOIN = 0;
int CJOIN = 0;
int FIRSTUSED = 1;
int REGNOTICE = 0;
int DATAUP = 0;
int news_size = -1L;
int shouldwritenew = 0;
float AKILL_PERCENT = 50.0;
int NICK_EXPIRE_MAIL = 3;
int allowmail = 0;

char *services_roots[32];
char *services_admins[32];

char *bannick[32];
char *banchan[32];
int nscount;
int cscount;

// Auto Settings

int clone_detect = 1;                   /* -clone detection */
int realname = 1;

int readonly = 0;			/* -readonly */
int snoop = 0;
int dumplog = 1;
int allow_flood = 1;
int allow_ignore = 1;

// *Auto Settings

char *time_zone = "GMT";
char *slog_filename = "./logs/services.log";
int update_timeout = 1800;

static int conf_break();

void init_conf(void)
{
  FILE *conf;
  unsigned char linbuff[1024];
  char *pargv[100];
  char *tmp, tmp2;
  int p;

  if ((conf = fopen(CONFIG_FILE, "rb")) == NULL)
  {
    fatal_perror("Error opening configuration file = services.conf");
  }

  while (!feof(conf))
  {
     if ((fgets(linbuff, 1024, conf)) == NULL)
     {
         break;
     }
     p = 0;
     tmp = strtok(linbuff, ": \n\r,");

     if (tmp != NULL)
     {
         pargv[p++] = tmp;
         while ((tmp = strtok(NULL, ": \n\r,")) != NULL)
         {
            pargv[p++] = tmp;
            if (p > 100) {
               break;
            }
         }
         if (conf_break(p, pargv) == -1) {
            slog("Services Terminated on illegal configuration");
            exit(1);
         }
    }
  }
  fclose(conf);
  if (!REMOTE_SERVER) {
     fatal_perror("ERROR: Missing S: line");
     exit(1);
  } else if (!REMOTE_PORT) {
     fatal_perror("ERROR: Missing P: line");
     exit(1);
  } else if (!PASSWORD) {
     fatal_perror("ERROR: Missing X: line");
     exit(1);
  } else if (!SERVER_NAME) {
     fatal_perror("ERROR: Missing N: line");
     exit(1);
  } else if (!SERVER_DESC) {
     fatal_perror("ERROR: Missing D: line");
     exit(1);
  } else if (!SERVICES_USER) {
     fatal_perror("ERROR: Missing U: line");
     exit(1);
  } else if (!SERVICES_HOST) {
     fatal_perror("ERROR: Missing H: line");
     exit(1);
  } else if (!NETWORK_NAME) {
     fatal_perror("ERROR: Missing A: line");
     exit(1);
  } else if (!SERVICES_MASTER) {
     fatal_perror("ERROR: Missing M: line");
     exit(1);
  } else
     return;
}


int conf_break(int pargc, char **pargv)
{
  char buf[64];
  int p, i;

   *buf=0;

   if (strlen(pargv[0]) > 1) {

     strcat(buf, pargv[0]);

     if (pargc != 2) {
        fatal_perror("Error in Option \"%s\"", pargv[0]);
        return -1;
     }
     if (!stricmp(buf, "NICKSERV") || !stricmp(buf, "NS")) {
         NICKSERV_NAME = sstrdup(pargv[1]);
         s_NickServ = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CHANSERV") || !stricmp(buf, "CS")) {
         CHANSERV_NAME = sstrdup(pargv[1]);
         s_ChanServ = sstrdup(pargv[1]);
         return 0;
     
     } else if (!stricmp(buf, "MEMOSERV") || !stricmp(buf, "MS")) {
         MEMOSERV_NAME = sstrdup(pargv[1]);
         s_MemoServ = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "HELPSERV") || !stricmp(buf, "HS")) {
         HELPSERV_NAME = sstrdup(pargv[1]);
         s_HelpServ = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "OPERSERV") || !stricmp(buf, "OS")) {
         OPERSERV_NAME = sstrdup(pargv[1]);
         s_OperServ = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ROOTSERV") || !stricmp(buf, "RS")) {
         ROOTSERV_NAME = sstrdup(pargv[1]);
         s_RootServ = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "GLOBAL")) {
         GLOBAL_NOTICER_NAME = sstrdup(pargv[1]);
         s_GlobalNoticer = sstrdup(pargv[1]);
         return 0;


     } else if (!stricmp(buf, "TIMEZONE") || !stricmp(buf, "TZ")) {
         TIMEZONE = sstrdup(pargv[1]);
         time_zone = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "LOG")) {
         SLOG_FILENAME = sstrdup(pargv[1]);
         slog_filename = sstrdup(pargv[1]);
         return 0;


     } else if (!stricmp(buf, "HELP")) {
          HELPSERV_DIR = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "UPDATE")) {
         UPDATE_TIMEOUT = atoi(pargv[1]);
         update_timeout = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "TIMEOUT")) {
         TIMEOUT_CHECK = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "READ")) {
         READ_TIMEOUT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "PW_LIMIT")) {
         BAD_PW_LIMIT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "PW_TIMEOUT")) {
         BAD_PW_TIMEOUT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CHANREG")) {
         CHANNEL_MAXREG = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CHANEXP")) {
         CHANNEL_EXPIRE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AKICK")) {
         AKICK_MAX = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AKICK_REASON")) {
         DEF_AKICK_REASON = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "NICKREG")) {
         NS_REG_DELAY = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "NICKEXP")) {
         NICK_EXPIRE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "RELEASE")) {
         RELEASE_TIMEOUT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MEMOMAX")) {
         DEF_MAX_MEMOS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MEMO_WAIT")) {
         MEMO_SEND_WAIT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MEMOEXP")) {
         MEMO_EXPIRE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ROOTS")) {
         char *services_roots[atoi(pargv[1])];
         MAX_SERVROOTS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ADMINS")) {
         char *services_admins[atoi(pargv[1])];
         MAX_SERVADMINS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "OPERS")) {
         char *services_opers[atoi(pargv[1])];
         MAX_SERVOPERS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "HELPOPS")) {
         char *services_helpers[atoi(pargv[1])];
         MAX_HELPOPS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AKILLS")) {
         MAX_AUTOKILLS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "JUPES")) {
         MAX_JUPES = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "TRIGGERS")) {
         MAX_TRIGGERS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AKILLEXP")) {
         AKILL_DEF_EXPIRY = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "IGNEXP")) {
         IGNORE_DEF_EXPIRY = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CLONES")) {
         CLONE_MIN_USERS = atoi(pargv[1]);
         return 0;


     } else if (!stricmp(buf, "CLONE_WARN")) {
         CLONE_WARNING_DELAY = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MEMO_LEN")) {
         MAX_MEMO_LENGTH = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "LOGS")) {
         ENABLE_LOGS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "C_ACC_MAX")) {
         CHAN_ACCESS_MAX = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "U_ACC_MAX")) {
         USER_ACCESS_MAX = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SUSPEND")) {
         MAX_SUSPEND = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "R_MODES")) {
         ENABLE_R_MODES = atoi(pargv[1]);
         return 0;
     
     } else if (!stricmp(buf, "UMODE_a")) {
         ENABLE_UMODE_a = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "QLINES")) {
         MAX_QLINES = atoi(pargv[1]);
         return 0;
     
     } else if (!stricmp(buf, "ZLINES")) {
         MAX_ZLINES = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "EMAIL")) {
         ALLOW_EMAIL = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "TLEV")) {
         F_TLEV = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "RESET")) {
         F_RESET = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "BACKUP")) {
         BACKUP_DB = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SNOOPCHAN")) {
         snoopchan = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_FLOOD")) {
         allow_flood = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_IGNORE")) {
         allow_ignore = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_RO")) {
         readonly = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_CLONES")) {
         clone_detect = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_RN")) {
         realname = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_LOG")) {
         dumplog = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SET_SNOOP")) {
         snoop = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CUSTOM")) {
         CUSTOM_NOTICE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "GENERIC")) {
         GENERIC_NOTICE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AKILL_REASON")) {
         INCLUDE_AKILL_REASON = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "EXTRA_SNOOP")) {
         EXTRA_SNOOP = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "REG_SAVES")) {
         REG_SAVES = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "DISPLAY_UPDATES")) {
         DISPLAY_UPDATES = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CHANNEL_INHABIT")) {
         CHANNEL_INHABIT = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "UPTIME")) {
         MOTD_UPTIME = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MOTD_UPDATE")) {
         MOTD_UPDATE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "MLOCK")) {
         char tmp[128];
         int add = 1;
         DEF_MLOCKS = sstrdup(pargv[1]);
            *tmp = 0;
            while (*DEF_MLOCKS) {
               switch(*DEF_MLOCKS++) {

                   case '+':
                      add = 1; strcat(tmp, "+"); break;

                   case '-':
                      add = 0; strcat(tmp, "-"); break;

                   case 'n':
                        strcat(tmp, "n");
                     break;

                   case 't':
                        strcat(tmp, "t");
                     break;

                   case 'i':
                        strcat(tmp, "i");
                     break;

                   case 'm':
                        strcat(tmp, "m");
                     break;

                   case 'p':
                        strcat(tmp, "p");
                     break;

                   case 's':
                        strcat(tmp, "s");
                    break;

                   case 'c':
                        strcat(tmp, "c");
                     break;

                   case 'r':
                        strcat(tmp, "r");
                     break;

                }
            }
            DEF_MLOCKS = sstrdup(tmp);
    
            if (!strchr(DEF_MLOCKS, 'n') && !strchr(DEF_MLOCKS, 't')
               && !strchr(DEF_MLOCKS, 'i') && !strchr(DEF_MLOCKS, 'm')
               && !strchr(DEF_MLOCKS, 's') && !strchr(DEF_MLOCKS, 'p')
               && !strchr(DEF_MLOCKS, 'c') && !strchr(DEF_MLOCKS, 'r')
               && !strchr(DEF_MLOCKS, '+')) {

            fatal_perror("Invalid MLOCKS \"%s\" in conf option MLOCK", pargv[1]);
            return -1;
         }
         return 0;

     } else if (!stricmp(buf, "TOPICFIX")) {
         TOPIC_PROBS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AUTO_HIDE")) {
         AUTO_NOHOST = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "NOHOST")) {
         NOHOST_CONF = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "KILL")) {
         NS_KILL = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SECURE")) {
         NS_SECURE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "PRIVATE")) {
         NS_PRIVATE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ACCESS")) {
         NS_DACCESS = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CHANX")) {
         CHANX = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SPRIV")) {
         SPRIV = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AUTOUP")) {
         AUTOUP = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "HIDEUME")) {
         HIDEUME = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ALLOWCLIST")) {
         ALLOWCLIST = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AUTOJOINCHANNEL")) {
         ACHANS = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "OPERCHAN")) {
         AOCHANS = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ANAME")) {
         ADMIN_NAME = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AMAIL")) {
         ADMIN_EMAIL = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "PMAIL")) {
         PASS_EMAIL = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "SENDMAIL_PATH")) {
         sendmail_path = sstrdup(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "AUTOJOIN")) {
         AUTOJOINC = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "OPERJOIN")) {
         OPERJOIN = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "CJOIN")) {
         CJOIN = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "FIRSTUSED")) {
         FIRSTUSED = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "REGNOTICE")) {
         REGNOTICE = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "ALLOWMAIL")) {
         allowmail = atoi(pargv[1]);
         return 0;

     } else if (!stricmp(buf, "PERCENT")) {
         AKILL_PERCENT = atof(pargv[1]);
         AKILL_PERCENT += .0;
	 return 0;
     } else if (!stricmp(buf, "SPAMNICK")) {
          s_SpamChecker = sstrdup(pargv[1]);
          return 0;
     } else if (!stricmp(buf, "SPAMUSER")) {
          SpamUser = sstrdup(pargv[1]);
          return 0;
     } else if (!stricmp(buf, "SPAMHOST")) {
          Spamhost = sstrdup(pargv[1]);
          return 0;
     } else if (!stricmp(buf, "NSURL")) {
          nsurl = sstrdup(pargv[1]);
          return 0;
     } else if (!stricmp(buf, "CSURL")) {
          csurl = sstrdup(pargv[1]);
          return 0;
     } else if (!stricmp(buf, "GUESTURL")) {
          guesturl = sstrdup(pargv[1]);
          return 0;
     } else {
//        fatal_perror("Unknown Option \"%s\"", pargv[0]);
//        return -1;
    }

   return 0;
  }

  switch (pargv[0][0])
  {
     case '#':
       {
          return 0;
       }
     case 'S':
       {
          if (pargc != 2) {
             fatal_perror("Invalid S: line");
             return -1;
          }
          REMOTE_SERVER = sstrdup(pargv[1]);
          remote_server = sstrdup(pargv[1]);
          return 0;
       }
     case 'P':
       {
          if (pargc != 2) {
             fatal_perror("Invalid P: line");
             return -1;
          }
          REMOTE_PORT = atoi(pargv[1]);
          remote_port = atoi(pargv[1]);
          return 0;
       }
     case 'X':
       {
          if (pargc != 2) {
             fatal_perror("Invalid X: line");
             return -1;
          }
          PASSWORD = sstrdup(pargv[1]);
          password = sstrdup(pargv[1]);
          return 0;
       }
     case 'N':
       {
          if (pargc != 2) {
             fatal_perror("Invalid N: line");
             return -1;
          }
          SERVER_NAME = sstrdup(pargv[1]);
          server_name = sstrdup(pargv[1]);

          return 0;
       }
     case 'D':
       {
          if (pargc == 0) {
            fatal_perror("Invalid D: line, DESC must contain atleast 1 param");
            return -1;
          }
          *buf = 0;
          i=1;

          while(i < pargc) {
             strcat(buf, pargv[i]);
             i++;
             if (i < pargc)
                strcat(buf, " ");
          }

          SERVER_DESC = sstrdup(buf);
          server_desc = sstrdup(buf);
          return 0;
       }
     case 'U':
       {
          if (pargc != 2) {
             fatal_perror("Invalid U: line");
             return -1;
          }
           SERVICES_USER = sstrdup(pargv[1]);
           services_user = sstrdup(pargv[1]);
          return 0;
       }
     case 'H':
       {
          if (pargc != 2) {
             fatal_perror("Invalid H: line");
             return -1;
          }
          SERVICES_HOST = sstrdup(pargv[1]);
          services_host = sstrdup(pargv[1]);
          return 0;
       }
     case 'A':
       {
          if (pargc != 2) {
             fatal_perror("Invalid A: line");
             return -1;
          }
          NETWORK_NAME = sstrdup(pargv[1]);
          return 0;
       }
     case 'M':
       {
          if (pargc != 2) {
             fatal_perror("Invalid M: line");
             return -1;
          }
          SERVICES_MASTER = sstrdup(pargv[1]);
          return 0;
       }
     case 'R':
       {
          if (pargc != 2) {
             fatal_perror("Invalid M2: line");
             return -1;
          }
          SERVICES_MASTER2 = sstrdup(pargv[1]);
          return 0;
       }
     default:
       {
         fatal_perror("Unknown Field in conf file: (%c)\n", pargv[0][0]);
         return -1;
       }
   }

  return 0;
}
